#!/usr/bin/perl
use Mysql;

#    RingWorld SQL v1.9 - webring management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Variables Section
open (F, "<rworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

######################################################################
# Main Section                                                       #
######################################################################
# Get data
print "HTTP/1.0 200 OK\n";
print "content-type: text/html\n\n";
if ($ENV{CONTENT_LENGTH}>0){if ($sysid eq "Windows"){read(STDIN,$data,$ENV{CONTENT_LENGTH});} else {$data=<STDIN>;}}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		$data{$field}=$value;
	}
}
$destination=$data{method};
$sth=$dbh->query("LOCK TABLES rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid,status FROM rw_users WHERE (username='$data{name}' AND password='$data{password}' AND acctype=1)");
($uid,$status)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if (!$uid)
{
	&closedb;
	print qq~<font size=4>ACCESS DENIED</font>
	~;
	exit;
}
if (!$status)
{
	&closedb;
	print qq~<font size=4>ACCESS DENIED</font>
	~;
	exit;
}
if ($status==2)
{
	&closedb;
	print qq~<font size=4>ACCESS DENIED</font>
	~;
	exit;
}
$destination=$data{method};
&$destination;
&closedb;
print qq~<font size=4>ACCESS DENIED</font>
~;
exit;
sub maillist
{
	open (F,"<$messpath/$uid.msg");
	@body=<F>;
	close (F);
	if ($data{recepient} eq "ringleader")
	{
		$sth=$dbh->query("LOCK TABLES rw_users READ, rw_rings READ") if ($locktables);
		$sth=$dbh->query("SELECT DISTINCT email,name FROM rw_users,rw_rings WHERE rw_rings.uid=rw_users.uid ORDER BY name");
		while (($email,$name)=$sth->fetchrow)
		{
			push(@eml,"$email\t$name");
		}
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	}
	else
	{
		$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
		$sth=$dbh->query("SELECT rid FROM rw_rings WHERE uid=$uid");
		$rid=$sth->fetchrow;
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
		$sth=$dbh->query("LOCK TABLES rw_users READ, rw_sites READ") if ($locktables);
		$sth=$dbh->query("SELECT DISTINCT email,name FROM rw_users,rw_sites WHERE (rid=$rid AND rw_sites.uid=rw_users.uid) ORDER BY name");
		while (($email,$name)=$sth->fetchrow)
		{
			push(@eml,"$email\t$name");
		}
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	}
	&closedb;
	$count=0;
	$total=@eml;
	$current=0;
	if (@eml>0)
	{
		foreach(@eml)
		{
			($email,$name)=split("\t",$_);
			$count++;
			open (MAIL,"|$mailprog");
			print MAIL "To: $email ($name)\n";
			print MAIL @body;
			print MAIL "\n.\n";
			close (MAIL);
			if (int($count/$total*100)>$current)
			{
				$differ=int($count/$total*100)-$current;
				$current+=$differ;
				$stb=qq~<img src="$ringworld/images/mailbar.gif" height=$differ width=96><br>\n~;
				$numb=4052-7-length($stb);
				$addln="A" x $numb;
				print qq~<!--$addln-->$stb~;
			}
		}
	}
	print qq~<font size=3>MAIL SENT</font>
	~;
	exit;
}
sub closedb
{
$sth="";
$dbh="";
}
