#!/usr/bin/perl
use Mysql;

#    RingWorld SQL v1.9 - webring management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Variables Section
open (F, "<rworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

######################################################################
# Main Section                                                       #
######################################################################
# Get data
sysread(STDIN,$data,$ENV{CONTENT_LENGTH});
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$data{$field}=$value;
	}
}
$encpw=substr(crypt($data{password},$data{password}),2);
&admin if ($admlogin eq $data{name} && $admpass eq $encpw);

# Autorization
$sth=$dbh->query("LOCK TABLES rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid,acctype,status,email FROM rw_users WHERE (username='$data{name}' AND password='$data{password}')");
($uid,$type,$status,$email)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if (!$uid)
{
	push(@errors,"Incorrect username or password<br>");
	&error(@errors);
}
if (!$status)
{
	push(@errors,"Your account is not approved yet<br>");
	&error(@errors);
}
if ($status==2)
{
	push(@errors,"Your account is disabled<br>");
	&error(@errors);
}
&owner if ($type==1);
&user if ($type==2);

sub user
{
$sth=$dbh->query("LOCK TABLES rw_sites READ") if ($locktables);
$sth=$dbh->query("SELECT sid,rid,sname,surl,sdescr,hits FROM rw_sites WHERE uid=$uid");
($sid,$rid,$titl,$uurl,$desc,$hits)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rname,hcode FROM rw_rings WHERE rid=$rid");
($fullrn,$htmlcode)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$desc=~s/\<br\>/\n/g;
$webring=$rid;
$user=$uid;
$selected[$status]="selected";
$htmlcode=~s/\~/\\\~/g;
eval "\$htmlcode=qq~$htmlcode~;";
$result=qq~
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>CHANGE USERDATA</center></font></td></tr>
<tr><td width="100%"><font face="Arial" size="2"><form action="$cgi/rwuser.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="chgenset">
<input type="text" name="title" value="$titl" size=38 maxlength=100> - Title<br>
<input type="text" name="url" value="$uurl" size=38 maxlength=100> - URL<br>
<textarea name="desc" cols=30 rows=3>$desc</textarea> - Description<br>
<input type="Submit" value="Change data"><br></form></font></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>ACCOUNT STATUS</center></font></td></tr>
<tr><td width="100%"><font face="Arial" size="2"><form action="$cgi/rwuser.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="status">
<select name="status"><option value="1" $selected[1]>Enabled</option><option value="3" $selected[3]>Suspended</option></select><input type="Submit" value="Change status"><br></form></font></td></tr>
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>YOUR HTML CODE</center></font></td></tr>
<tr><td width="100%"><font face="Arial" size="2"><form><center><textarea cols=48 rows=10>&lt;!--Begin $title code--&gt;\n$htmlcode\n&lt;!--End $title code--&gt;</textarea></center></form></font></td></tr>
~;
&closedb;
open(F,"<$rwpath/template/user.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub owner
{
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rname,rurl,rdescr,caid FROM rw_rings WHERE uid=$uid");
($rname,$rurl,$rdescr,$rcaid)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$rdescr=~s/\<br\>/\n/gi;
$sth=$dbh->query("LOCK TABLES rw_categories READ") if ($locktables);
$sth=$dbh->query("SELECT caid,category,subcategory FROM rw_categories ORDER BY category,subcategory");
while (($caid,$category,$subcategory)=$sth->fetchrow)
{
	if ($caid==$rcaid)
	{
		$cats.="<option value=\"$caid\" selected>$category:$subcategory</option>\n";
	}
	else
	{
		$cats.="<option value=\"$caid\">$category:$subcategory</option>\n";
	}
}
$result=qq~
<tr><td><form action="$cgi/rwowner.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="chgenset">
<table cellpadding=0 cellspacing=0 width="100%">
<tr><td width="100%" colspan=4 bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>CHANGE WEBRING INFORMATION</center></font></td></tr>
<tr><td width="25%"><font face="Arial" size="2">Ringname:</font></td><td width="25%"><input type="text" name="uname" value="$rname" size=15 maxlength=50></td><td width="25%"><font face="Arial" size="2">E-Mail:</font></td><td width="25%"><input type="text" value="$email" name="email" size=15 maxlength=50></td></tr>
<tr><td width="25%"><font face="Arial" size="2">WebRing URL:</font></td><td width="75%" colspan=3 align="right"><input type=text name="wurl" size=55 value="$rurl"></td></tr>
<tr><td width="25%"><font face="Arial" size="2">WebRing description:</font></td><td width="75%" colspan=3 align="right"><textarea name="description" cols=41 rows=4 wrap="virtual">$rdescr</textarea></td></tr>
<tr><td width="25%"><font face="Arial" size="2">Category:</font></td><td width="75%" colspan=3 align="right"><select name="categ">$cats</select></td></tr>
<tr><td width="100%" colspan=4 align="right"><input type="Submit" name="Submit" value="Change"></td></tr>
</table></form></td></tr>
<tr><td>
~;
&closedb;
open(F,"<$rwpath/template/owner.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub error
{
@errors=@_;
&closedb;
open(F,"<$rwpath/template/error.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}	
sub closedb
{
$sth="";
$dbh="";
}
